<?php

namespace Drupal\monarch_vue_field\Plugin\Field\FieldFormatter;

use Monarch\VueApp;
use Drupal\Core\Field\FormatterBase;
use Drupal\Core\Field\FieldItemListInterface;

/**
 * Plugin base for vue app formatters.
 *
 * @FieldFormatter(
 *   id = "vue_app_default",
 *   label = @Translation("No Vue App"),
 *   field_types = {
 *     "vue_app"
 *   }
 * )
 */
class VueAppDefaultFormatter extends FormatterBase {

  const APP_NAME = 'no_app';
  const APP_NAME_ATTRIBUTE = 'data-vue-app';
  const APP_LIBRARIES = [];

  /**
   * Add modify the data before it's passed to the app.
   *
   * @param mixed $data
   *   The data stored for the app.
   * @param \Drupal\Core\Field\FieldItemListInterface $items
   *   The field items.
   *
   * @return mixed
   *   The data that will be passed to the app.
   */
  protected function dataAlter($data, FieldItemListInterface $items) {
    return $data;
  }

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    return VueApp::create(static::APP_NAME, static::APP_LIBRARIES, static::APP_NAME_ATTRIBUTE)
      ->render($this->dataAlter($items->data ?? [], $items));
  }

}
